#!/bin/bash

# Virgil CGI Scanner 0.9
# Marc Ruef <marc.ruef@computec.ch>

# Angabe, um was fuer eine Dokumentart es sich handelt
echo -e "Content-type: text/html\n"

# Versionsnummer
VER="0.9"

headereingabecmd() {
# Hier wird der HTML-Header geladen
echo "<html>"
echo "<head>"
echo " <title>Virgil CGI Scanner $VER</title>"
echo " <meta name=Description content=\"Freier Online-CGI-Scanner\">"
echo " <meta name=Keywords content=\"security, scanner, securityscanner, audit, penetration test, cgi, httpd, stealth, whisker, apache, iis, report\">"
echo " <meta http-equiv=Content-Type content=text/html; charset=windows-1252>"
echo " <meta http-equiv=Content-Language content=de>"
echo "</head>"
echo "<body text=#000000 bgcolor=#FFFFFF link=#0000EE vlink=#551A8B alink=#FF0000>"
# Der Scan-Header mit Menu
echo "<a name=oben><h2>Virgil CGI Scanner $VER</h2>"
echo "<hr size=1 noshade width=100%><br>"
echo "<form action=\"$SCRIPT_NAME\" method=get>"
}

aeusseretabellecmd() {
# Die aeusserste Tabelle
echo "<table border=0 cellspacing=1 cellpadding=0 cols=2 width=100%>"
echo "<tr valign=top><td>"

# Kurze Beschreibung des Tabellenaufbaus
#
#  ------------------
# | Aeussere Tabelle |
# |  --------------  |
# | |  xA1  |      | |
# | |-------+  xB  | |
# | |  xA2  |      | |
# |  --------------  |
#  ------------------
}

tabelleea1cmd() {
# Tabelle EA1, Konfiguration Zielsystem
echo "<h3>Konfiguration Zielsystem</h3>"
echo "<table border=0 cellspacing=1 cellpadding=0 cols=3 width=400>"
echo "<tr><td nowrap width=190>Zielsystem</td><td nowrap width=10>:</td><td nowrap width=200><nobr>http://<input type=text name=tar size=30 maxlenght=30 value=$REMOTE_ADDR></nobr></td></tr>"
echo "<tr><td nowrap>Zielport</td><td nowrap>:</td><td nowrap>TCP-Port <input type=text name=zielport size=5 maxlenght=5 value=80></td></tr>"
echo "</table>"
}

tabelleea2cmd() {
# Tabelle EA2, konfiguration Scanvorgang
echo "<h3>Konfiguration Scanvorgang</h3>"
echo "<table border=0 cellspacing=1 cellpadding=0 cols=3 width=400>"
echo "<tr><td nowrap width=190>Geschwindigkeit</td><td nowrap width=10>:</td><td nowrap width=200><select size=1 name=geschwindigkeit><option>Schnell</option><option>Langsam</option></select></td></tr>"
echo "<tr><td nowrap>IDS-Evasion</td><td nowrap>:</td><td nowrap><input type=checkbox name=ids value=evasion></td></tr>"
echo "</table>"
# Die Buttons, schreiben wir noch in Tabelle EA2
echo "<br>"
echo "<font size=-1><b>Warnung</b>: Das Scannen von Systemen ohne die Erlaubnis des Besitzers und/oder Verwalters ist strafbar und wird strafrechtlich verfolgt. Aus diesem Grund wird Ihre IP-Adresse ($REMOTE_ADDR) protokolliert und auf unbestimmte Zeit aufbewahrt.</font><br><br>"
echo "<input type=submit value=Scannen> "
echo "<input type=reset value=Abbrechen>"
echo "</form>"
}

tabelleebcmd() {
# Tabelle EB, Ausgabe der Statistik fuer die letzten 10 Scans
    echo "</td><td>"
    echo "<h3>Die letzten 10 Scans</h3>"
    echo "<table border=1 cellspacing=1 cellpadding=1 width=100%>"
        echo "<tr><td><b>Datum</b></td><td><b>Quellsystem</b></td><td><b>Zielsystem</b></td><td><b>Zielport</b></td></tr>"
        for HEADLINE in 1 2 3 4 5 6 7 8 9 10; do
	    STATDATUM=`cat /tmp/virgil.scans |tail -n $HEADLINE |head -n 1 |awk 'BEGIN{FS=";"}{print $1}'`
    	    STATQUELLSYSTEM=`cat /tmp/virgil.scans |tail -n $HEADLINE |head -n 1 |awk 'BEGIN{FS=";"}{print $2}'`
	    STATZIELSYSTEM=`cat /tmp/virgil.scans |tail -n $HEADLINE |head -n 1 |awk 'BEGIN{FS=";"}{print $3}'`
	    STATZIELPORT=`cat /tmp/virgil.scans |tail -n $HEADLINE |head -n 1 |awk 'BEGIN{FS=";"}{print $4}'`
	    echo "<tr>"
	    echo "<td nowrap>$STATDATUM</td>"
	    echo "<td nowrap><a href=http://www.samspade.org/t/lookat?a=$STATQUELLSYSTEM target=_TOP>$STATQUELLSYSTEM</a></td>"
	    echo "<td nowrap><a href=http://www.samspade.org/t/lookat?a=$STATZIELSYSTEM target=_TOP>$STATZIELSYSTEM</a></td>"
	    echo "<td nowrap><a href=http://$STATZIELSYSTEM:$STATZIELPORT target=_TOP>$STATZIELPORT</a></td>"
	    echo "</tr>"
	done
    echo "</table>"
echo "</td></tr></table>"
}

eingabeumbiegenscancmd() {
# Eingabe fuer den Scan zurichten
TARGET=`echo $QUERY_STRING | awk 'BEGIN{FS="&"}{print $1}' |sed s/"tar="//`
ZIELPORT=`echo $QUERY_STRING | awk 'BEGIN{FS="&"}{print $2}' |sed s/"zielport="// |sed "s/-//g"`
GESCHWINDIGKEIT=`echo $QUERY_STRING | awk 'BEGIN{FS="&"}{print $3}' |sed s/"geschwindigkeit="//`
IDSEVASION=`echo $QUERY_STRING | awk 'BEGIN{FS="&"}{print $4}' |sed s/"ids="//`

# Targetfehler vermeiden
case "`host $TARGET`" in
#case "`echo $TARGET |tr A-Z a-z`" in
    # Localhost-Attacken vermeiden
    *localhost*|*" 127."*)
        TARGET=$REMOTE_ADDR;;
    # RFC1918-Attacken vermeiden
    *" 192.168."*|*" 172.16."*|*" 172.17."*|*" 172.18."*|*" 172.19."*|*" 172.20."*|*" 172.21."*|*" 172.22."*|*" 172.23."*|*" 172.24."*|*" 172.25."*|*" 172.26."*|*" 172.27."*|*" 172.28."*|*" 172.29."*|*" 172.30."*|*" 172.31."*|*" 10."*)
	FEHLERMELDUNG="Sie haben sich an der Kompromittierung dieses Virgil CGI Scanners probiert. Ihre IP-Adresse $REMOTE_ADDR wurde geloggt und entsprechende juristische Schritte werden eingeleitet werden. Have a nice day!"
	fehlermeldungcmd
	exit;;
    # Wichtige Domain-Attacken vermeiden
    *computec.ch*|*security-guide.ch*|*snort.*|*giac.*|*sias.*|*nessus.*|*ccc.de*|*bank*)
	FEHLERMELDUNG="Das von Ihnen anvisierte Ziel $TARGET wurde bei diesem Virgil CGI Scanner in die Blacklist eingetragen und als &quot;sensibles&quot; System klassifiziert. Aus diesem Grund sind Scanversuche von diesem Virgil Scanner aus nicht m&ouml;glich."
	fehlermeldungcmd
	exit;;
    # Wichtige Top-Level-Domain-Attacken vermeiden
    *.gov*|*.mil*|*.arpa*|*.gov.uk*)
	FEHLERMELDUNG="Das von Ihnen anvisierte Ziel $TARGET wurde bei diesem Virgil CGI Scanner in die Blacklist eingetragen und als &quot;sensibles&quot; System klassifiziert. Aus diesem Grund sind Scanversuche von diesem Virgil Scanner aus nicht m&ouml;glich."
	fehlermeldungcmd
	exit;;
    # Firewall-Attacken vermeiden
    *firewall.*|*fw.*|*proxy.*|*gateway.*|*gw.*|*ids.*|*router.*)
	FEHLERMELDUNG="Das von Ihnen anvisierte Ziel $TARGET wurde bei diesem Virgil CGI Scanner in die Blacklist eingetragen und als &quot;sensibles&quot; System klassifiziert. Aus diesem Grund sind Scanversuche von diesem Virgil Scanner aus nicht m&ouml;glich."
	fehlermeldungcmd
	exit;;
esac
}

headerscanningcmd() {
echo "<html>"
echo "<head>"
echo " <title>Virgil Report f&uuml;r $TARGET</title>"
echo " <meta name=Description content=\"Freier Online-CGI-Scanner\">"
echo " <meta name=Keywords content=\"security, scanner, securityscanner, audit, penetration test, dante, report\">"
echo " <meta http-equiv=Content-Type content=text/html; charset=windows-1252>"
echo " <meta http-equiv=Content-Language content=de>"
echo "</head>"
echo "<body text=#000000 bgcolor=#FFFFFF link=#0000EE vlink=#551A8B alink=#FF0000>"

# Der Scan-Header mit Menu
echo "<a name=oben><h2>Virgil Report f&uuml;r $TARGET</h2>"
echo "<hr size=1 noshade width=100%><br>"
echo "<form action=\"$SCRIPT_NAME\" method=get>"
}

pausenzeitenfestlegencmd() {
if [ "$IDSEVASION" == "evasion" -o "$GESCHWINDIGKEIT" == "Langsam" ]
then
    PAUSENZEIT=0.5	# Wieviele Sekunden wird pro Check gewartet
    SCANDAUER=300	# Wie lange dauert der gesamte Scan in etwa
else
    PAUSENZEIT=0	# Wieviele Sekunden wird pro Check gewartet
    SCANDAUER=60	# Wie lange dauert der gesamte Scan in etwa
fi
}

bannerabgreifencmd() {
BANNER=`echo -e "HEAD / HTTP/1.0\n\n" |nc -w 10 $TARGET $ZIELPORT`
if [ $? -eq 0 ]
then # Falls das Banner-Abgreifen erfolgreich war
    echo "$BANNER" |grep Content > /dev/null
    if [ $? -eq 0 ]
    then # Falls es sich um einen HTTP-Banner handelt
	SERVER=`echo "$BANNER" |grep "Server: " |sed s/"Server: "//`
    else # Falls es sich nicht um einen HTTP-Banner handelt
	FEHLERMELDUNG="Sie haben einen Zugriffsversuch auf den Nicht-HTTP-Port $ZIELPORT des Systems $TARGET versucht. Der Virgil CGI Scanner ist lediglich in der Lage Webserver auf Schwachstellen zu &uuml;berpr&uuml;fen. Versuchen Sie beim System $TARGET den TCP-Port 80 (HTTP) oder 443 (SHTTP) anzusprechen."
	fehlermeldungcmd
	exit
    fi
else # Falls der Zielport nicht erreichbar war
    FEHLERMELDUNG="Es wurden keine Tests durchgef&uuml;hrt, denn der TCP-Port $ZIELPORT des Zielsystems $TARGET scheint nicht offen bzw. ansprechbar zu sein. Diese Information wird mit einer Eingabe von &quot;<tt>\`echo -e \"HEAD / HTTP/1.0\\n\\n\" | nc -w 10 $TARGET $ZIELPORT\`</tt>&quot; eingeholt. Falschmeldungen in diesem Belang sind nahezu ausgeschlossen. ersuchen Sie zu verifizieren, ob der TCP-Port $ZIELPORT des Zielsystems $TARGET wirklich von diesem Virgil CGI Scanner ansprechbar sein kann und sich dahinter in Webserver verbirgt."
    fehlermeldungcmd
    exit
fi
}

logfileschreibencmd() {
echo "`date`;$REMOTE_ADDR;$TARGET;$ZIELPORT;$GESCHWINDIGKEIT;$LAERMPEGEL;$SERVER" >> /tmp/virgil.scans
}

tabellesa1cmd() {
echo "<h3>Scaninformationen</h3>"
echo "<table border=0 cellspacing=1 cellpadding=0 width=100%>"
echo "<tr><td nowrap width=40%>Datum</td><td nowrap width=4%>:</td><td nowrap width=56%>`date`</td></tr>"
echo "<tr><td nowrap>Zielsystem</td><td>:</td><td nowrap><a href=http://www.samspade.org/t/lookat?a=$TARGET target=_TOP>$TARGET</a></td></tr>"
echo "<tr><td nowrap>Zielport</td><td>:</td><td nowrap><a href=http://$TARGET:$ZIELPORT target=_TOP>TCP-Port $ZIELPORT</a></td></tr>"
echo "<tr><td nowrap>Zielport-Status</td><td nowrap>:</td><td nowrap>offen, nicht gefiltert</td></tr>"
echo "<tr><td nowrap>HTTP-Daemon</td><td>:</td nowrap><td nowrap>$SERVER</td></tr>"
echo "</table><br>"

echo "<table border=0 cellspacing=1 cellpadding=0 width=100%>"
echo "<tr><td nowrap width=40%>Ihre IP-Adresse</td><td nowrap width=4%>:</td><td nowrap width=56%><a href=http://www.samspade.org/t/lookat?a=$REMOTE_ADDR target=_TOP>$REMOTE_ADDR</td></tr>"
echo "<tr><td nowrap>Ihr Quellport</td><td>:</td><td nowrap>TCP-Port $REMOTE_PORT</td></tr>"
echo "<tr><td nowrap>Ihr Webbrowser</td><td>:</td><td nowrap>$HTTP_USER_AGENT</td></tr>"
echo "</table><br>"
}

tabellesa2cmd() {
echo "</td><td>"
echo "<h3>Banner des Zielsystems</h3>"
echo "<table border=0 cellspacing=1 cellpadding=0 width=100%>"
echo "<tr><td nowrap><pre>$BANNER</pre></td></tr></table>"
echo "</td></tr></table>"
}

webserveridentifizierencmd() {
case "$SERVER" in *IIS*|*Microsoft*|*Win*)
    DATABASE=iis.db
esac

# Apache oder Unix-Webserver identifizieren
case "$SERVER" in *Apache*|*Unix*|*Linux*|*Solaris*|*Sun*)
    DATABASE=apache.db
esac

# Netscape-Webserver identifizieren
case "$SERVER" in *Netscape*)
    DATABASE=netscape.db
esac

# Falls der Webserver nicht identifiziert werden konnten, dann scannen wird alles
if [ -z "$SERVER" ]
then
    DATABASE="iis.db apache.db netscape.db"
fi
}

checksdurchfuehrencmd() {
echo "<h3>Gefundene Schwachstellen</h3>"
echo "Der Scan wird nun durchgef&uuml;hrt - Bitte haben Sie einen Augenblick Geduld (ca. $SCANDAUER Sekunden) ..."

# Daten von vorangegangenen Scans aus dem Weg raeumen
rm -f /tmp/$TARGET-$ZIELPORT.virgil

# Setzen die Anzahl der bisher durchgefuehrten Scans auf 0
SCAN=0
echo "<ol>"
for CHECK in `cat allgemein.db $DATABASE`
do
    sleep $PAUSENZEIT
    echo -e "HEAD /$CHECK HTTP/1.0\n\n" |nc -w 5 "$TARGET" "$ZIELPORT" |grep "200 OK" > /dev/null && echo "<li><a href=http://$TARGET:$ZIELPORT/$CHECK target=_TOP>http://$TARGET:$ZIELPORT/$CHECK</a></li>" |tee -a /tmp/$TARGET-$ZIELPORT.virgil &
    SCAN=`expr $SCAN + 1`
done

# Wir warten auf die Child-Prozesse, um kein Durcheinander zu kriegen
wait
}

gefundeneschwachstellencmd() {
# Falls keine Schwachstellen gefunden wurden, dann eine Fehlermeldung schreiben
if [ ! -s /tmp/$TARGET-$ZIELPORT.virgil ]
then
    echo "<li>Es konnten keine potentiellen Schwachstellen ausgemacht werden.</li>"
fi
}

scanfootercmd() {
# Der Scan-Footer
echo "</ol>Das Zielsystem wurde innerhalb von $SECONDS Sekunden erfolgreich auf $SCAN Schwachstellen &uuml;berpr&uuml;ft.<br><br>"
}

htmlfootercmd() {
# Der HTML-Footer
echo "<hr size=1 noshade width=100%><br>
[<a href=$SCRIPT_NAME>Neuer Scan</a>] [<a href=#oben>Nach oben</a>] [<a href=$SCRIPT_NAME?$QUERY_STRING>Scan widerholen</a>]
<br><br><hr size=1 noshade width=100%>
<font size=-2>Dieses Dokument wurde durch den CGI-Scanner des Virgil Projekts
generiert - <a href=http://www.computec.ch target=_TOP>
http://www.computec.ch</a></font><a name=unten>
</html>"

# Wir raeumen auf
rm -f /tmp/$TARGET-$ZIELPORT.virgil
}

# Tabelle EF (Fehlermeldung)
tabelleefcmd() {
echo "</td><td>"
echo "<h3>Fehlermeldung</h3>"
echo "<table border=0 cellspacing=1 cellpadding=0 width=100%>"
echo "<tr><td>$FEHLERMELDUNG</td></tr></table>"
echo "</td></tr></table>"
}

# Fehlermeldung ausgeben. Der Meldungstext ist in der Variable $FEHLERMELDUNG
fehlermeldungcmd() {
headereingabecmd # HTML-Header fuer Eingabe laden
aeusseretabellecmd # Laden der aeusseren Tabelle
tabelleea1cmd # Tabelle EA1 (Konfiguration Zielsystem) laden
tabelleea2cmd # Tabelle EA2 (Konfiguration Scanvorgang) laden
tabelleefcmd # Tabelle EF (Fehlermeldung) laden
htmlfootercmd # HTML-Footer laden
}

### Eigentliches Main-Codesegment ###

# Als erstes CGI-Attacken auf den Virgil CGI Scanner vermeiden
case "$QUERY_STRING" in
    *..*|*"\\"*|*"~"*|*"*"*|*%*|*etc*|*passwd*)
	FEHLERMELDUNG="Sie haben sich an der Kompromittierung dieses Virgil CGI Scanners probiert. Ihre IP-Adresse $REMOTE_ADDR wurde geloggt und entsprechende juristische Schritte werden eingeleitet werden. Have a nice day!"
	fehlermeldungcmd
	exit;;
esac

# Der Ablauf des Skripts
if [ -z "$QUERY_STRING" ]
then # Die Eingabemaske anzeigen, falls keine Eingabe gemacht wurde
    headereingabecmd # HTML-Header fuer Eingabe laden
    aeusseretabellecmd # Laden der aeusseren Tabelle
    tabelleea1cmd # Tabelle EA1 (Konfiguration Zielsystem) laden
    tabelleea2cmd # Tabelle EA2 (Konfiguration Scanvorgang) laden
    tabelleebcmd # Tabelle EB (Die letzten 10 Scans) laden
    htmlfootercmd # HTML-Footer laden
else # Die Scans durchfuehren, falls was angegeben wurde
    eingabeumbiegenscancmd # Query-String anpassen
    bannerabgreifencmd # Banner beim Ziel abgreifen
    headerscanningcmd # HTML-Header fuer Scanning laden
    pausenzeitenfestlegencmd # Pausenzeiten festlegen
    logfileschreibencmd # Daten des Scans ins Logfile schreiben
    aeusseretabellecmd # Laden der aeusseren Tabelle
    tabellesa1cmd # Tabellen SA1 (Scaninformationen) laden
    tabellesa2cmd # Tabelle SA2 (Banner Zielsystem) laden
    webserveridentifizierencmd # Eingesetzten Webserver identifizieren
    checksdurchfuehrencmd # Die eigentlichen HTTP-Checks durchfuehren
    gefundeneschwachstellencmd # Meldung falls keine Schwachstellen
    scanfootercmd # Scan-Footer ausgeben
    htmlfootercmd # HTML-Footer laden
    fi
fi
